<?php

namespace DataView;

class ProtokollPunkt_protokoll {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderTabTableAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getProtokoll()) && (\FOP\User::getProtokoll())) && (!\FOP\User::getIsGuest())) { ?><?php if (\FOP\Database::query('SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($id))->fetchColumn() == 1) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="var self = this; $.get(reloadprotokollPunkt_protokoll({action: 'open', fop_table: 'protokollPunkt', fop_id: '_', fop_from: location.href}, true)).then(function () { open_url(self.href, false);}); return false;" href="<?php echo htmlentities(\TablesRouter\ProtokollPunkt::createURL2(['from' => \FOP\Util::getBackUrl(), 'column_protokoll' => $id])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Protokoll-Punkt'))); ?></a><?php } ?><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_protokollPunkt_protokoll']) ? intval($_GET['page_protokollPunkt_protokoll']) : 0);
								$addlines = (isset($_GET['addlines_protokollPunkt_protokoll']) ? intval($_GET['addlines_protokollPunkt_protokoll']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET, $id);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'nummer',
												'desc' => _('Tagesordnungspunkt'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['nummer'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'content',
												'desc' => _('Beschreibung'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['content'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'ergebnis',
												'desc' => _('Ergebnis'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['ergebnis'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('protokollPunkt_protokoll'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='nummer'
												data-order='<?php echo intval($columns['nummer']['order']); ?>'
												data-width='<?php echo intval($columns['nummer']['width']); ?>'
												data-collapsed='<?php echo intval($columns['nummer']['collapsed']); ?>'
												style='width: <?php echo intval($columns['nummer']['width']); ?>px; <?php if ($columns['nummer']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadprotokollPunkt_protokoll(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_protokollPunkt_protokoll_nummer'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_protokollPunkt_protokoll_nummer'] = text.val(); } else { delete query['search_protokollPunkt_protokoll_nummer']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_protokollPunkt_protokoll_nummer'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_protokollPunkt_protokoll_nummer'] = text2.val(); } else { delete query['searchnot_protokollPunkt_protokoll_nummer']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_protokollPunkt_protokoll'] == 'nummer ASC') {
			query['sort_protokollPunkt_protokoll'] = 'nummer DESC';
		 } else if (query['sort_protokollPunkt_protokoll'] == 'nummer DESC') {
		 	delete query['sort_protokollPunkt_protokoll'];
		 } else {
			query['sort_protokollPunkt_protokoll'] = 'nummer ASC';
		 }
		 reloadprotokollPunkt_protokoll();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Tagesordnungspunkt')); ?>'><?php echo(_('Tagesordnungspunkt')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'nummer ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'nummer DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_protokollPunkt_protokoll_nummer']) || isset($_GET['range_max_protokollPunkt_protokoll_nummer']) || isset($_GET['deps_protokollPunkt_protokoll_nummer']) || isset($_GET['fullsearch_protokollPunkt_protokoll_nummer']) || isset($_GET['dynamic_protokollPunkt_protokoll_nummer']) || isset($_GET['search_protokollPunkt_protokoll_nummer']) || isset($_GET['searchnot_protokollPunkt_protokoll_nummer']) || isset($_GET['filter_protokollPunkt_protokoll_nummer'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['nummer']['header'] = ob_get_contents(); ob_end_clean();
											$columns['nummer']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['nummer']['width']); ?>px; <?php if ($columns['nummer']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='nummer'><span class='overflow-text' title="<?php echo htmlentities($item['nummer']); ?>"><?php echo htmlentities($item['nummer']); ?></span></div><?php
											};
											$columns['nummer']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='nummer'
													data-order='<?php echo intval($columns['nummer']['order']); ?>'
													data-width='<?php echo intval($columns['nummer']['width']); ?>'
													data-collapsed='<?php echo intval($columns['nummer']['collapsed']); ?>'
													style='width: <?php echo intval($columns['nummer']['width']); ?>px; <?php if ($columns['nummer']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='content'
												data-order='<?php echo intval($columns['content']['order']); ?>'
												data-width='<?php echo intval($columns['content']['width']); ?>'
												data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
												style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadprotokollPunkt_protokoll(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_protokollPunkt_protokoll_content'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_protokollPunkt_protokoll_content'] = text.val(); } else { delete query['search_protokollPunkt_protokoll_content']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_protokollPunkt_protokoll_content'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_protokollPunkt_protokoll_content'] = text2.val(); } else { delete query['searchnot_protokollPunkt_protokoll_content']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_protokollPunkt_protokoll'] == 'content ASC') {
			query['sort_protokollPunkt_protokoll'] = 'content DESC';
		 } else if (query['sort_protokollPunkt_protokoll'] == 'content DESC') {
		 	delete query['sort_protokollPunkt_protokoll'];
		 } else {
			query['sort_protokollPunkt_protokoll'] = 'content ASC';
		 }
		 reloadprotokollPunkt_protokoll();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Beschreibung')); ?>'><?php echo(_('Beschreibung')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'content ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'content DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_protokollPunkt_protokoll_content']) || isset($_GET['range_max_protokollPunkt_protokoll_content']) || isset($_GET['deps_protokollPunkt_protokoll_content']) || isset($_GET['fullsearch_protokollPunkt_protokoll_content']) || isset($_GET['dynamic_protokollPunkt_protokoll_content']) || isset($_GET['search_protokollPunkt_protokoll_content']) || isset($_GET['searchnot_protokollPunkt_protokoll_content']) || isset($_GET['filter_protokollPunkt_protokoll_content'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['content']['header'] = ob_get_contents(); ob_end_clean();
											$columns['content']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='content'><?php 
	$html = preg_replace('/^<!DOCTYPE.+?>/m', '', \FOP\Sanitizers::htmlentities_decode($item['content'])); ?>
	<span style="display: block;" onmouseenter='handleHTMLOverlay(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' onmouseleave='handleHTMLOverlayFade(event, &apos;#overlayFormcontent<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' ng-non-bindable><?php echo htmlentities(mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content'])))), 0, 50) . (strlen(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['content']))))) >= 50 ? '...' : ''));  ?></span>
	<div class="overlay-iframe" id="overlayFormcontent<?php echo $item['ID'] ?? 'fail'; ?>">
		<div class="iframe-container" id="iframecontainer">
			<?php echo \FOP\Util::SanitizeUserHtml($html); ?>
		</div>
	</div>
</div><?php
											};
											$columns['content']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='content'
													data-order='<?php echo intval($columns['content']['order']); ?>'
													data-width='<?php echo intval($columns['content']['width']); ?>'
													data-collapsed='<?php echo intval($columns['content']['collapsed']); ?>'
													style='width: <?php echo intval($columns['content']['width']); ?>px; <?php if ($columns['content']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='ergebnis'
												data-order='<?php echo intval($columns['ergebnis']['order']); ?>'
												data-width='<?php echo intval($columns['ergebnis']['width']); ?>'
												data-collapsed='<?php echo intval($columns['ergebnis']['collapsed']); ?>'
												style='width: <?php echo intval($columns['ergebnis']['width']); ?>px; <?php if ($columns['ergebnis']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadprotokollPunkt_protokoll(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_protokollPunkt_protokoll_ergebnis'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_protokollPunkt_protokoll_ergebnis'] = text.val(); } else { delete query['search_protokollPunkt_protokoll_ergebnis']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_protokollPunkt_protokoll_ergebnis'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_protokollPunkt_protokoll_ergebnis'] = text2.val(); } else { delete query['searchnot_protokollPunkt_protokoll_ergebnis']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_protokollPunkt_protokoll'] == 'ergebnis ASC') {
			query['sort_protokollPunkt_protokoll'] = 'ergebnis DESC';
		 } else if (query['sort_protokollPunkt_protokoll'] == 'ergebnis DESC') {
		 	delete query['sort_protokollPunkt_protokoll'];
		 } else {
			query['sort_protokollPunkt_protokoll'] = 'ergebnis ASC';
		 }
		 reloadprotokollPunkt_protokoll();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Ergebnis')); ?>'><?php echo(_('Ergebnis')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'ergebnis ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_protokollPunkt_protokoll']) && $_GET['sort_protokollPunkt_protokoll'] == 'ergebnis DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_protokollPunkt_protokoll_ergebnis']) || isset($_GET['range_max_protokollPunkt_protokoll_ergebnis']) || isset($_GET['deps_protokollPunkt_protokoll_ergebnis']) || isset($_GET['fullsearch_protokollPunkt_protokoll_ergebnis']) || isset($_GET['dynamic_protokollPunkt_protokoll_ergebnis']) || isset($_GET['search_protokollPunkt_protokoll_ergebnis']) || isset($_GET['searchnot_protokollPunkt_protokoll_ergebnis']) || isset($_GET['filter_protokollPunkt_protokoll_ergebnis'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['ergebnis']['header'] = ob_get_contents(); ob_end_clean();
											$columns['ergebnis']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['ergebnis']['width']); ?>px; <?php if ($columns['ergebnis']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='ergebnis'><?php 
	$html = preg_replace('/^<!DOCTYPE.+?>/m', '', \FOP\Sanitizers::htmlentities_decode($item['ergebnis'])); ?>
	<span style="display: block;" onmouseenter='handleHTMLOverlay(event, &apos;#overlayFormergebnis<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' onmouseleave='handleHTMLOverlayFade(event, &apos;#overlayFormergebnis<?php echo htmlentities($item['ID'] ?? 'fail'); ?>&apos;);' ng-non-bindable><?php echo htmlentities(mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['ergebnis'])))), 0, 50) . (strlen(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($item['ergebnis']))))) >= 50 ? '...' : ''));  ?></span>
	<div class="overlay-iframe" id="overlayFormergebnis<?php echo $item['ID'] ?? 'fail'; ?>">
		<div class="iframe-container" id="iframecontainer">
			<?php echo \FOP\Util::SanitizeUserHtml($html); ?>
		</div>
	</div>
</div><?php
											};
											$columns['ergebnis']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='ergebnis'
													data-order='<?php echo intval($columns['ergebnis']['order']); ?>'
													data-width='<?php echo intval($columns['ergebnis']['width']); ?>'
													data-collapsed='<?php echo intval($columns['ergebnis']['collapsed']); ?>'
													style='width: <?php echo intval($columns['ergebnis']['width']); ?>px; <?php if ($columns['ergebnis']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#protokollPunkt_protokoll-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#protokollPunkt_protokoll-table .fop-table-header .fop-table-column .title,
										#protokollPunkt_protokoll-table .fop-column-handle,
										#protokollPunkt_protokoll-table .fop-table-row,
										#protokollPunkt_protokoll-table .fop-table-row .fop-table-column,
										#protokollPunkt_protokoll-table .fop-table-column-multicontrol,
										#protokollPunkt_protokoll-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="protokollPunkt_protokoll">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="protokollPunkt_protokoll__all-checkbox">
														<input class="mdl-checkbox__input" id="protokollPunkt_protokoll__all-checkbox" type="checkbox" onchange="checkprotokollPunkt_protokoll('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon protokollPunkt_protokoll__mass-action" style='visibility: hidden;' onclick="$.get('DataView/ProtokollPunkt_protokoll/permissions?id=' + checkprotokollPunkt_protokoll(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_protokollPunkt_protokoll_') == 0 || key.indexOf('range_max_protokollPunkt_protokoll_') == 0 || key.indexOf('deps_protokollPunkt_protokoll_') == 0 || key.indexOf('fullsearch_protokollPunkt_protokoll_') == 0 || key.indexOf('dynamic_protokollPunkt_protokoll_') == 0 || key.indexOf('search_protokollPunkt_protokoll_') == 0 || key.indexOf('searchnot_protokollPunkt_protokoll_') == 0 || key.indexOf('filter_protokollPunkt_protokoll_') == 0) delete query[key]; reloadprotokollPunkt_protokoll(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_protokollPunkt_protokoll_ID'] = checkprotokollPunkt_protokoll(null, 'ID'); delete query['page_protokollPunkt_protokoll']; reloadprotokollPunkt_protokoll(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkprotokollPunkt_protokoll(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkprotokollPunkt_protokoll(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((\FOP\User::getProtokoll()) && (\FOP\User::getProtokoll()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/ProtokollPunkt/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkprotokollPunkt_protokoll(null, 'ID'))).then(function () { reloadprotokollPunkt_protokoll(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('protokollPunkt_protokoll', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'protokollPunkt_protokoll', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_protokollPunkt_protokoll" <?php \EasyEditor\Navigation::printScroll('dv.ProtokollPunkt_protokoll', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_protokollPunkt_protokoll\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_protokollPunkt_protokoll\'] = wantedPage;
														reloadprotokollPunkt_protokoll(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-protokollPunkt-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadprotokollPunkt_protokoll({action: \'open\', fop_table: \'protokollPunkt\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox protokollPunkt_protokoll__checkbox protokollPunkt_protokoll__checkbox protokollPunkt_protokoll__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="protokollPunkt_protokoll__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="protokollPunkt_protokoll__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkprotokollPunkt_protokoll(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon protokollPunkt_protokoll__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-protokollPunkt_protokoll-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\ProtokollPunkt::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadprotokollPunkt_protokoll({action: 'open', fop_table: 'protokollPunkt', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\ProtokollPunkt::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/ProtokollPunkt/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadprotokollPunkt_protokoll(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="protokollPunkt" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\ProtokollPunkt::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadprotokollPunkt_protokoll();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="protokollPunkt" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\ProtokollPunkt::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadprotokollPunkt_protokoll({action: 'open', fop_table: 'protokollPunkt', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadprotokollPunkt_protokoll();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function renderScript($id) { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_protokollPunkt_protokoll_protokollListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_protokollPunkt_protokoll_protokoll', val, cb.checked);
		  } else {
			  delete query['filter_protokollPunkt_protokoll_protokoll'];
		  }reloadprotokollPunkt_protokoll();
        
    }

		var i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout = null;
		function changefilter_protokollPunkt_protokoll_protokollSearchFilter(val, callback) {
			if(i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout) clearTimeout(i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout);

			i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout = setTimeout(function() {
				$.getJSON(reloadprotokollPunkt_protokoll({action: 'getfilter_protokollPunkt_protokoll_protokollItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_protokollPunkt_protokoll_protokoll_orig'] = val;
				});
			}, 300);
		}

	function getfilter_protokollPunkt_protokoll_protokollListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_protokollPunkt_protokoll_protokoll_orig']) ? json_encode($_GET['filter_protokollPunkt_protokoll_protokoll_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936" type="text">' +
			'<label class="mdl-textfield__label" for="27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_protokollPunkt_protokoll_protokoll', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_protokollPunkt_protokoll_protokoll_orig'] = '';
					delete query['filter_protokollPunkt_protokoll_protokoll'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadprotokollPunkt_protokoll();
					
				} else {
					$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_protokollPunkt_protokoll_protokollSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\ProtokollPunkt_protokoll::getfilter_protokollPunkt_protokoll_protokollItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_protokollPunkt_protokoll_protokoll_orig'] = '';
				delete query['filter_protokollPunkt_protokoll_protokoll'];
				reload('', items);reloadprotokollPunkt_protokoll();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_protokollPunkt_protokoll_protokoll', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_protokollPunkt_protokoll_protokollListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_protokollPunkt_protokoll_protokollListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_protokollPunkt_protokoll_protokoll', val, cb.checked);
		  } else {
			  delete query['filter_protokollPunkt_protokoll_protokoll'];
		  }reloadprotokollPunkt_protokoll();
        
    }

		var i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout = null;
		function changefilter_protokollPunkt_protokoll_protokollSearchFilter(val, callback) {
			if(i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout) clearTimeout(i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout);

			i27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936timeout = setTimeout(function() {
				$.getJSON(reloadprotokollPunkt_protokoll({action: 'getfilter_protokollPunkt_protokoll_protokollItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_protokollPunkt_protokoll_protokoll_orig'] = val;
				});
			}, 300);
		}

	function getfilter_protokollPunkt_protokoll_protokollListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_protokollPunkt_protokoll_protokoll_orig']) ? json_encode($_GET['filter_protokollPunkt_protokoll_protokoll_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936" type="text">' +
			'<label class="mdl-textfield__label" for="27a319fd6ebd3640536821fedfa8174d246590742f7ecfce1ee3a9cf3138e936">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_protokollPunkt_protokoll_protokoll', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_protokollPunkt_protokoll_protokoll_orig'] = '';
					delete query['filter_protokollPunkt_protokoll_protokoll'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadprotokollPunkt_protokoll();
					
				} else {
					$('#table_protokollPunkt_protokoll').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_protokollPunkt_protokoll_protokollSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\ProtokollPunkt_protokoll::getfilter_protokollPunkt_protokoll_protokollItemsByStringAction('', $id));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_protokollPunkt_protokoll_protokoll_orig'] = '';
				delete query['filter_protokollPunkt_protokoll_protokoll'];
				reload('', items);reloadprotokollPunkt_protokoll();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_protokollPunkt_protokoll_protokoll', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_protokollPunkt_protokoll_protokollListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberprotokollPunkt_protokoll(col) {
										//var checklist = window.DataViewChecked['protokollPunkt_protokoll'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['protokollPunkt_protokoll'] && window.DataViewChecked['protokollPunkt_protokoll'][col].ranges.length > 0) {
											$('.protokollPunkt_protokoll__mass-action').css('visibility', 'visible');
											$('.protokollPunkt_protokoll__action').css('visibility', 'hidden');
										} else {
											$('.protokollPunkt_protokoll__mass-action').css('visibility', 'hidden');
											$('.protokollPunkt_protokoll__action').css('visibility', 'visible');
										}
										$('.protokollPunkt_protokoll__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('protokollPunkt_protokoll__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('protokollPunkt_protokoll__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadprotokollPunkt_protokoll (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										nq["id"] = <?php echo json_encode($id); ?>; 
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/ProtokollPunkt_protokoll/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if (((\FOP\User::getProtokoll()) && (\FOP\User::getProtokoll())) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/ProtokollPunkt_protokoll/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#protokollPunkt_protokoll-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#protokollPunkt_protokoll-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#protokollPunkt_protokoll-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberprotokollPunkt_protokoll('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#protokollPunkt_protokoll-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadprotokollPunkt_protokoll()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkprotokollPunkt_protokoll (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['protokollPunkt_protokoll']) window.DataViewChecked['protokollPunkt_protokoll'] = {};
										if (!window.DataViewChecked['protokollPunkt_protokoll'][col]) window.DataViewChecked['protokollPunkt_protokoll'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['protokollPunkt_protokoll'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadprotokollPunkt_protokoll({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['protokollPunkt_protokoll'][col] = new IDList(ids);
													updateNumberprotokollPunkt_protokoll(col);
												});
											} else {
												window.DataViewChecked['protokollPunkt_protokoll'][col] = new IDList();
												updateNumberprotokollPunkt_protokoll(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#protokollPunkt_protokoll__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['protokollPunkt_protokoll'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['protokollPunkt_protokoll'][col].push(id);
												} else {
													window.DataViewChecked['protokollPunkt_protokoll'][col].remove(id);
												}
											}
											updateNumberprotokollPunkt_protokoll(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadprotokollPunkt_protokoll();
			
		}

	</script>
	<?php
	
    
  }

  public static function getSQL($params, $id) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* content */ '.qi('content').' AS '.qi('content').',
									/* ergebnis */ '.qi('ergebnis').' AS '.qi('ergebnis').',
									/* nummer */ '.qi('nummer').' AS '.qi('nummer').',
									/* operation::create */ ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('O3t2RXGP').' WHERE '.qi('O3t2RXGP').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AS '.qi('operation::create').',
									/* operation::delete */ ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('sgt3BpgQ').' WHERE '.qi('sgt3BpgQ').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AS '.qi('operation::delete').',
									/* operation::edit */ ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('IifUUeVT').' WHERE '.qi('IifUUeVT').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('4BLhYEDH').' WHERE '.qi('4BLhYEDH').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AS '.qi('operation::view').',
									/* protokoll */ '.qi('protokoll').' AS '.qi('protokoll').',
									/* protokoll::canView */ '.qi('ref:protokoll').'.'.qi('protokoll:canView').' AS '.qi('protokoll::canView').',
									/* protokoll::description */ '.qi('ref:protokoll').'.'.qi('protokoll:description').' AS '.qi('protokoll::description').',
									1
								FROM '.qi('protokollPunkt').' '.qi('protokollPunkt').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('protokoll:ID').', CONCAT('.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('protokoll').'.'.qi('date').')'.(\FOP\Database::getDriver() == 'mysql' ? '' : '::date') . ', '.\FOP\Database::sessionVarSQL('dateformat').'), \': \', '.qi('protokoll').'.'.qi('bez').') AS '.qi('protokoll:description').', (('.\FOP\Database::quote(\FOP\User::getProtokoll()).')) AS '.qi('protokoll:canView').' FROM '.qi('protokoll').') '.qi('ref:protokoll').' ON '.qi('ref:protokoll').'.'.qi('protokoll:ID').' = '.qi('protokoll').'
								WHERE ('.qi('protokoll').' = ' . \FOP\Database::quote($id) . ')
									AND (('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('4BLhYEDH').' WHERE '.qi('4BLhYEDH').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).'))) AS t
								WHERE ' . (isset($params['filter_protokollPunkt_protokoll_protokoll']) ? ($params['filter_protokollPunkt_protokoll_protokoll'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollPunkt_protokoll_protokoll']))->toSQL('t.'.qi('protokoll').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollPunkt_protokoll_nummer']) ? ($params['filter_protokollPunkt_protokoll_nummer'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollPunkt_protokoll_nummer']))->toSQL('t.'.qi('nummer').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollPunkt_protokoll_content']) ? ($params['filter_protokollPunkt_protokoll_content'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollPunkt_protokoll_content']))->toSQL('t.'.qi('content').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollPunkt_protokoll_ergebnis']) ? ($params['filter_protokollPunkt_protokoll_ergebnis'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollPunkt_protokoll_ergebnis']))->toSQL('t.'.qi('ergebnis').'') . ') AND ') : '') : '') . 
								(isset($params['filter_protokollPunkt_protokoll_ID']) ? ($params['filter_protokollPunkt_protokoll_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_protokollPunkt_protokoll_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_protokollPunkt_protokoll_nummer']) ? 't.'.qi('nummer').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll_nummer'] . '%') . ' AND ' : '') . 
								(isset($params['search_protokollPunkt_protokoll_content']) ? 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll_content'] . '%') . ' AND ' : '') . 
								(isset($params['search_protokollPunkt_protokoll_ergebnis']) ? 't.'.qi('ergebnis').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll_ergebnis'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_protokollPunkt_protokoll_nummer']) ? 'NOT t.'.qi('nummer').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_protokollPunkt_protokoll_nummer'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_protokollPunkt_protokoll_content']) ? 'NOT t.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_protokollPunkt_protokoll_content'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_protokollPunkt_protokoll_ergebnis']) ? 'NOT t.'.qi('ergebnis').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_protokollPunkt_protokoll_ergebnis'] . '%') . ' AND ' : '') . 
								(isset($params['search_protokollPunkt_protokoll']) ? '(' . 't.'.qi('nummer').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll'] . '%') . ' OR ' . 't.'.qi('content').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll'] . '%') . ' OR ' . 't.'.qi('ergebnis').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_protokollPunkt_protokoll'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getidsAction($col, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET, $id));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE (('.\FOP\Database::quote(\FOP\User::getProtokoll()).') AND (COALESCE((SELECT ('.\FOP\Database::quote(\FOP\User::getProtokoll()).') FROM '.qi('protokoll').' '.qi('sgt3BpgQ').' WHERE '.qi('sgt3BpgQ').'.'.qi('ID').' = '.qi('protokollPunkt').'.'.qi('protokoll').' LIMIT 1), FALSE)) AND ('.\FOP\Database::quote(\FOP\User::getProtokoll()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('protokollPunkt').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getfilter_protokollPunkt_protokoll_protokollItemsByStringAction($fstr, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_protokollPunkt_protokoll_protokoll']);
		return \Types\Protokoll::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('protokoll').''.self::getSQL($params, $id).')');
	

    
  }

  public static function getData($sqladdon, $params, $id, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params, $id);

								$order = (\FOP\Util::array_value(array(
									'content ASC' => 'ORDER BY t.'.qi('content').' ASC',
									'ergebnis ASC' => 'ORDER BY t.'.qi('ergebnis').' ASC',
									'nummer ASC' => 'ORDER BY t.'.qi('nummer').' ASC',
									'content DESC' => 'ORDER BY t.'.qi('content').' DESC',
									'ergebnis DESC' => 'ORDER BY t.'.qi('ergebnis').' DESC',
									'nummer DESC' => 'ORDER BY t.'.qi('nummer').' DESC',
									'' => ''), isset($params['sort_protokollPunkt_protokoll']) ? $params['sort_protokollPunkt_protokoll'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['protokoll'] = \FOP\Sanitizers::null_converter($item['protokoll']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['protokoll'] = \FOP\Sanitizers::null_converter($item['protokoll']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		if (isset($params['filter_protokollPunkt_protokoll_nummer'])) {
		if ($params['filter_protokollPunkt_protokoll_nummer'] == '_null') {
			array_push($filters, _('Tagesordnungspunkt') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollPunkt_protokoll_nummer']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Tagesordnungspunkt') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_protokollPunkt_protokoll_content'])) {
		if ($params['filter_protokollPunkt_protokoll_content'] == '_null') {
			array_push($filters, _('Beschreibung') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollPunkt_protokoll_content']))->all() AS $val) {
				$value = mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($val)))), 0, 20) . (strlen($val) >= 20 ? '...' : '');
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Beschreibung') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_protokollPunkt_protokoll_ergebnis'])) {
		if ($params['filter_protokollPunkt_protokoll_ergebnis'] == '_null') {
			array_push($filters, _('Ergebnis') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollPunkt_protokoll_ergebnis']))->all() AS $val) {
				$value = mb_substr(preg_replace('/[ \t\r\n]+/', ' ', strip_tags(preg_replace('/<style.*?\/style>/s', '', html_entity_decode($val)))), 0, 20) . (strlen($val) >= 20 ? '...' : '');
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Ergebnis') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_protokollPunkt_protokoll_protokoll'])) {
		if ($params['filter_protokollPunkt_protokoll_protokoll'] == '_null') {
			array_push($filters, _('Protokoll') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_protokollPunkt_protokoll_protokoll']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT CONCAT('.(\FOP\Database::getDriver() == 'mysql' ? 'DATE_FORMAT(FROM_UNIXTIME' : 'to_char(to_timestamp') . '('.qi('protokoll').'.'.qi('date').')'.(\FOP\Database::getDriver() == 'mysql' ? '' : '::date') . ', '.\FOP\Database::sessionVarSQL('dateformat').'), \': \', '.qi('protokoll').'.'.qi('bez').') AS description FROM '.qi('protokoll').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Protokoll') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_protokollPunkt_protokoll_nummer'])) {
		array_push($filters, _('nummer') . ' ' . _('filter_contains') . ' ' . $params['search_protokollPunkt_protokoll_nummer']);
	}if (isset($params['search_protokollPunkt_protokoll_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains') . ' ' . $params['search_protokollPunkt_protokoll_content']);
	}if (isset($params['search_protokollPunkt_protokoll_ergebnis'])) {
		array_push($filters, _('ergebnis') . ' ' . _('filter_contains') . ' ' . $params['search_protokollPunkt_protokoll_ergebnis']);
	}if (isset($params['searchnot_protokollPunkt_protokoll_nummer'])) {
		array_push($filters, _('nummer') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_protokollPunkt_protokoll_nummer']);
	}if (isset($params['searchnot_protokollPunkt_protokoll_content'])) {
		array_push($filters, _('content') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_protokollPunkt_protokoll_content']);
	}if (isset($params['searchnot_protokollPunkt_protokoll_ergebnis'])) {
		array_push($filters, _('ergebnis') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_protokollPunkt_protokoll_ergebnis']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_protokollPunkt_protokoll_\')) delete query[q];} reloadprotokollPunkt_protokoll(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from, $id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'protokollPunkt') {
	\FOP\Session::setPayload('dv-protokollPunkt', [
		'id' => 'protokollPunkt_protokoll',
		'tbl' => 'protokollPunkt',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\ProtokollPunkt_protokoll::stepURL('protokollPunkt', 'XXX', -1),
		'next' => \DataViewRouter\ProtokollPunkt_protokoll::stepURL('protokollPunkt', 'XXX',  1),
		'from' => $fop_from,
		'param_id' => $id
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\ProtokollPunkt::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query, $dv['param_id']);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



